VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Getwhwnd sample from BlackBeltVB.com"
   ClientHeight    =   5160
   ClientLeft      =   1965
   ClientTop       =   1545
   ClientWidth     =   8250
   LinkTopic       =   "Form1"
   ScaleHeight     =   5160
   ScaleWidth      =   8250
   Begin VB.ListBox List2 
      Height          =   4545
      Left            =   4800
      TabIndex        =   2
      Top             =   480
      Width           =   3375
   End
   Begin VB.ListBox List1 
      Height          =   4545
      Left            =   120
      TabIndex        =   0
      Top             =   480
      Width           =   4575
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Child Handles"
      Height          =   255
      Index           =   1
      Left            =   5040
      TabIndex        =   3
      Top             =   120
      Width           =   2895
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Parent Handles && Titles"
      Height          =   255
      Index           =   0
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   4335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Getwhwnd sample from BlackBeltVB.com
' http://blackbeltvb.com
'
' Written by Matt Hart
' Copyright 1999 by Matt Hart
' 
' This software is FREEWARE. You may use it as you see fit for 
' your own projects but you may not re-sell the original or the 
' source code. Do not copy this sample to a collection, such as
' a CD-ROM archive. You may link directly to the original sample
' using "http://blackbeltvb.com/getwhwnd.htm"
' 
' No warranty express or implied, is given as to the use of this
' program. Use at your own risk.
'
' This example shows how to use the new Callback / ENum capabilities of
' Visual Basic 5.0.  The GetWhWnd.Bas module contains the Callback
' procedure - EnumWindowsProc.  The parameters of this Callback are
' specified by the Windows SDK.  This ENumWindows call is one of the most
' useful, yet the API text does not contain the needed declarations.
' Another problem with the API text is that it does not contain the
' Callback procedure declaration.  I had to look at the User32.Dll file
' to see if I needed to Declare ENumWindows using an Alias (I did not),
' and I had to translate the C declaration listed in the SDK to Visual Basic,
' which I got right after a couple of VB crashes <grin>.
'
' Anyway, once you have all of the Window handles, you can do pretty much
' anything with that program.  This particular example fills a list box with
' the handle numbers and Window Titles of all open top level (Parent) windows.
' Note the extra GetWindowLong call before adding it to the list.  This call
' gets the Parent of this window.  If it has no parent, then it's a top level
' window. ;-)
'
' I've recently added the ENumChildWindows to this. It also does a GetWindowText.
' However, you often have to use other methods to figure out what kind of control
' it is, and whether it is the one you want.  You should experiment with the different
' calls which retrieve information about a window, given its handle.

Private Declare Function EnumChildWindows Lib "user32" (ByVal hWndParent As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Const GWL_HWNDPARENT = (-8)

Private Sub Form_Load()
    ReDim lHandles(0) As Long
    GetWindowHandles
    Dim l As Long, i As Long, a$
    a$ = Space$(128)
    For i = 1 To UBound(lHandles)
        l = GetWindowLong(lHandles(i), GWL_HWNDPARENT)
        If l = 0 Then
            l = GetWindowText(lHandles(i), a$, 128)
            List1.AddItem lHandles(i) & vbTab & Left$(a$, l)
        End If
    Next
End Sub

Private Sub List1_Click()
    List2.Clear
    ReDim lHandles(0) As Long
    Dim h As Long, a$, l As Long, i As Long
    a$ = List1.List(List1.ListIndex)
    h = Val(Left$(a$, InStr(a$, vbTab) - 1))
    l = EnumChildWindows(h, AddressOf EnumChildWindowsProc, 0)
    a$ = Space$(128)
    For i = 1 To UBound(lHandles)
        l = GetWindowText(lHandles(i), a$, 128)
        List2.AddItem lHandles(i) & vbTab & Left$(a$, l)
    Next
End Sub
